
<template>
    <!-- eslint-disable -->
    
    <div class="mb-10 pb-10">
        <!--Modals-->
        <editGuideModal ref="refEditGuideModal" @updateGuide="updateGuide"/>
        <CreatePDFModal ref="refCreatePDFModal" :orders="orders" @saveLabel="saveLabel" />
        

        <v-data-table
            :headers="headersPackages"
            :items="itemsTables"
            :single-expand="singleExpand"
            :expanded.sync="expanded"
            item-key="id"
            show-expand
            :loading="loading"
            class="elevation-1"
        >
    
            <template v-slot:item.actions="{ item }">
                <v-icon
                    small
                    class="mr-2"
                    @click="deleteItem(item.id)"
                    :disabled="blockButton"
                >
                mdi-delete
                </v-icon>
                <v-icon
                    small
                    class="mr-2"
                    @click="sendCoordinadora(item)"
                    :disabled="(item.state == 0) || blockButton"
                    v-show="item.stateCode == 0"
                >
                mdi-send-outline
                </v-icon>
                
                <v-icon
                    small
                    class="mr-2"
                    @click="editGuideFields(item)"
                    :disabled="(item.state == 0) || blockButton"
                    v-show="item.stateCode == 0"
                >
                mdi-clipboard-edit
                </v-icon>
    
                <v-icon
                    small
                    class="mr-2"
                    @click="generatePdf(item.id)"
                    v-show="(item.stateCode != 0) && (item.stateCode != 4)"
                    :disabled="blockButton"
                >
                mdi-file-pdf-box
                </v-icon>

                <v-icon
                    small
                    class="mr-2"
                    @click="cancelGuide(item.id)"
                    v-show="(item.stateCode != 0) && (item.stateCode != 4)"
                    :disabled="blockButton"
                >
                mdi-file-document-remove
                </v-icon>
    
    
            </template>
    
            <template v-slot:expanded-item="{ headers, item }">
                <td :colspan="headers.length">
                    <v-data-table
                        :headers="headerPackage"
                        :footer-props="{ disablePagination : true, disableItemsPerPage : true }"
                        :disable-sort="true"
                        hide-default-footer
                        :items="item.pack.boxes"
                    ></v-data-table>
                </td>
            </template>
    
        </v-data-table>
    </div>

    
</template>
<script setup>
    import { onMounted, ref, reactive, computed, watch, nextTick } from 'vue';
    import { HttpReq } from '@/utilies/httpRequest';
    import router from '@/router';
    import store from '@/store';
    import editGuideModal from '@/components/editGuideModal.vue';
    import CreatePDFModal from '@/components/CreatePDFModal.vue';

    const loading = ref(true)
    const orders = ref([])

    const blockButton = ref(false)

    const headersPackages = [
        {
            text: 'Nombre operador',
            align: 'start',
            value: 'operatorName'
        },
        {
            text: "Cliente",
            value: "fullnameCustomer"
        },
        {
            text: "fecha",
            value: "date"
        },
        {
            text: "Tipo de envio",
            value: "serviceLevel"
        },
        {
            text: "Estado",
            value: "state"
        },
        {
            text: "Acciones",
            value: 'actions',
            sortable: false
        }
    ]

    const headerPackage = [
        {
            text: 'Alto',
            align: 'start',
            value: 'height'
        },
        {
            text: 'Ancho',
            value: 'width'
        },
        {
            text: 'Largo',
            value: 'longer'
        },
        {
            text: 'Peso',
            value: 'width'
        },
        {
            text: 'Nombre paquete',
            value: 'packageName'
        },
        {
            text: 'Referencia',
            value: 'reference'
        }
    ]

    const serviceLevel = ref({
        0: "Error",
        1: "Estandar",
        2: "Express",
        3: "Programado"
    })

    const stateGuide = ref({
        0: "Información generada",
        1: "Guia generada",
        2: "Despacho generado",
        3: "Error",
        4: "Guía Cancelada"
    })

    const itemsTables = ref([])

    const singleExpand = ref(false)
    const expanded = ref([])

    const refEditGuideModal = ref(null)
    const refCreatePDFModal = ref(null)

    onMounted(() => {
        store.dispatch('loadStorage')
        getDataFromApi()
    })

    async function deleteItem(id) {
        blockButton.value = true
        let resp = await HttpReq.deleteData(id, 'guide')
        console.log("resp: ", resp)
        if(resp.status == 200) {
            itemsTables.value = itemsTables.value.filter(item => item.id != id)
            store.dispatch('openModal', {
                title: "Eliminación",
                body: "Se ha eliminado correctamente la guía",
                type: 1
            })
        } else {
            store.dispatch('openModal', {
                title: "Eliminación",
                body: "No se pudo eliminar la guía hubo un problema en el servidor",
                type: 2
            })
        }
        blockButton.value = false
    }

    function generatePdf(id) {
        refCreatePDFModal.value.openModal(id)
    }

    function saveLabel(id, data) {
        let indexOrder = orders.value.findIndex(itemOrder => itemOrder.id == id)
        orders.value[indexOrder].generateLabel = data
    }

    function editGuideFields(item) {
        refEditGuideModal.value.openModal({...item.pack}, item.id)
    }

    async function sendCoordinadora(item) {
        blockButton.value = true
        let resp = await HttpReq.putData({}, 'soap/generateguia', item.id )

        if(resp.status == 200) {
            let generateGuide = resp.data
            let indexOrder = orders.value.findIndex(itemOrder => itemOrder.id == item.id)
            orders.value[indexOrder].generateGuide.codeRemission = generateGuide.codeRemission
            orders.value[indexOrder].generateGuide.pdfGuide = generateGuide.pdfGuide
            orders.value[indexOrder].generateGuide.reference = generateGuide.reference
            orders.value[indexOrder].generateGuide.remissionId = generateGuide.remissionId
            orders.value[indexOrder].generateGuide.url = generateGuide.url
            orders.value[indexOrder].pack.state = 1
            itemsTables.value[indexOrder].stateCode = 1
            itemsTables.value[indexOrder].state = 1
            item.state = stateGuide.value[1]
            store.dispatch('openModal', {
                title: "Generando guía",
                body: "Se ha generado exitosamente",
                type: 1
            })
        } else {
            store.dispatch('openModal', {
                title: "Generando guía",
                body: "Hubo un error en el servidor, comunicarse con admin",
                type: 2
            })
        }
        blockButton.value = false
    }

    function updateGuide(data, guideFields_id) {
        let index = orders.value.findIndex(order => order.id == guideFields_id )
        if(index >= 0 ) {
            orders.value[index].pack = data
            itemsTables.value[index].pack = data 
            itemsTables.value[index].serviceLevel = serviceLevel.value[data.serviceLevel]
        }
    }

    async function cancelGuide(id) {
        blockButton.value = true
        let resp = await HttpReq.putData({}, 'soap/cancelguide',id)
        console.log("resp: ", resp)
        if(resp.status == 200) {
            let index = itemsTables.value.findIndex(item => item.id == id)
            console.log("index: ", index)
            if(index == -1)
                return
            //itemsTables.value[index].pack.stateCode = 4
            //itemsTables.value[index].pack.state = "Guía Cancelada"
            itemsTables.value[index].stateCode = 4
            itemsTables.value[index].state = stateGuide.value[4]

            store.dispatch('openModal', {
                title: "Cancelar guía",
                body: "La guía se ha cancelado exitosamente",
                type: 1
            })
        } else {
            store.dispatch('openModal', {
                title: "Cancelar guía",
                body: "No se pudo eliminar la guia, comunicarse con administrador",
                type: 2
            })
        }
        blockButton.value = false
    }

    async function getDataFromApi() {
        loading.value = true
        
        let resp = await HttpReq.getData('package');

        if(resp.status == 200) {
            orders.value = resp.data
            itemsTables.value = orders.value.map(item => {
                return {
                    id: item.id,
                    operatorName: item.pack.operatorName,
                    fullnameCustomer: item.fullnameCustomer,
                    date: item.pack.date.substring(0,10),
                    serviceLevel: serviceLevel.value[item.pack.serviceLevel], //shippingType.value[item.pack.shippingType],
                    state: stateGuide.value[item.pack.state],
                    stateCode: item.pack.state,
                    pack: {
                        boxes: item.pack.boxes,
                        contents: item.pack.contents,
                        date: item.pack.date.substring(0,10),
                        declaredValue: item.pack.declaredValue,
                        id: item.pack.id,
                        invoice: item.pack.invoice,
                        observation: item.pack.observation,
                        operatorName: item.pack.operatorName,
                        orderNumbers: item.pack.orderNumbers,
                        serviceLevel: item.pack.serviceLevel,
                        state: item.pack.state
                    }
                }
            })
            loading.value = false
        } else {
            store.dispatch('openModal', {
                title: "Error obtener datos",
                body: "Error en el servidor",
                type: 2
            })
        }
    }
</script>
<style>

</style>